/* Generated by CIL v. 1.5.1 */
/* print_CIL_Input is false */

#line 20 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned char __u8;
#line 23 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned short __u16;
#line 26 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned int __u32;
#line 30 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned long long __u64;
#line 15 "include/asm-generic/int-ll64.h"
typedef signed char s8;
#line 16 "include/asm-generic/int-ll64.h"
typedef unsigned char u8;
#line 19 "include/asm-generic/int-ll64.h"
typedef unsigned short u16;
#line 21 "include/asm-generic/int-ll64.h"
typedef int s32;
#line 22 "include/asm-generic/int-ll64.h"
typedef unsigned int u32;
#line 24 "include/asm-generic/int-ll64.h"
typedef long long s64;
#line 25 "include/asm-generic/int-ll64.h"
typedef unsigned long long u64;
#line 14 "./include/uapi/asm-generic/posix_types.h"
typedef long __kernel_long_t;
#line 15 "./include/uapi/asm-generic/posix_types.h"
typedef unsigned long __kernel_ulong_t;
#line 48 "./include/uapi/asm-generic/posix_types.h"
typedef unsigned int __kernel_uid32_t;
#line 49 "./include/uapi/asm-generic/posix_types.h"
typedef unsigned int __kernel_gid32_t;
#line 71 "./include/uapi/asm-generic/posix_types.h"
typedef __kernel_ulong_t __kernel_size_t;
#line 72 "./include/uapi/asm-generic/posix_types.h"
typedef __kernel_long_t __kernel_ssize_t;
#line 87 "./include/uapi/asm-generic/posix_types.h"
typedef long long __kernel_loff_t;
#line 229 "include/linux/compiler.h"
struct kernel_symbol {
   unsigned long value ;
   char const   *name ;
};
#line 33 "include/linux/export.h"
struct module;
#line 12 "include/linux/types.h"
typedef __u32 __kernel_dev_t;
#line 15 "include/linux/types.h"
typedef __kernel_dev_t dev_t;
#line 18 "include/linux/types.h"
typedef unsigned short umode_t;
#line 29 "include/linux/types.h"
typedef _Bool bool;
#line 31 "include/linux/types.h"
typedef __kernel_uid32_t uid_t;
#line 32 "include/linux/types.h"
typedef __kernel_gid32_t gid_t;
#line 45 "include/linux/types.h"
typedef __kernel_loff_t loff_t;
#line 54 "include/linux/types.h"
typedef __kernel_size_t size_t;
#line 59 "include/linux/types.h"
typedef __kernel_ssize_t ssize_t;
#line 108 "include/linux/types.h"
typedef __u32 uint32_t;
#line 157 "include/linux/types.h"
typedef unsigned int gfp_t;
#line 162 "include/linux/types.h"
typedef u64 phys_addr_t;
#line 167 "include/linux/types.h"
typedef phys_addr_t resource_size_t;
#line 177 "include/linux/types.h"
struct __anonstruct_atomic_t_6 {
   int counter ;
};
#line 177 "include/linux/types.h"
typedef struct __anonstruct_atomic_t_6 atomic_t;
#line 182 "include/linux/types.h"
struct __anonstruct_atomic64_t_7 {
   long counter ;
};
#line 182 "include/linux/types.h"
typedef struct __anonstruct_atomic64_t_7 atomic64_t;
#line 183 "include/linux/types.h"
struct list_head {
   struct list_head *next ;
   struct list_head *prev ;
};
#line 188
struct hlist_node;
#line 192 "include/linux/types.h"
struct hlist_node {
   struct hlist_node *next ;
   struct hlist_node **pprev ;
};
#line 203 "include/linux/types.h"
struct callback_head {
   struct callback_head *next ;
   void (*func)(struct callback_head * ) ;
};
#line 15 "./arch/x86/include/asm/pgtable_64_types.h"
typedef unsigned long pgdval_t;
#line 16 "./arch/x86/include/asm/pgtable_64_types.h"
typedef unsigned long pgprotval_t;
#line 20 "./arch/x86/include/asm/pgtable_64_types.h"
struct pgprot {
   pgprotval_t pgprot ;
};
#line 218 "./arch/x86/include/asm/pgtable_types.h"
typedef struct pgprot pgprot_t;
#line 220 "./arch/x86/include/asm/pgtable_types.h"
struct __anonstruct_pgd_t_12 {
   pgdval_t pgd ;
};
#line 220 "./arch/x86/include/asm/pgtable_types.h"
typedef struct __anonstruct_pgd_t_12 pgd_t;
#line 372
struct file;
#line 385
struct seq_file;
#line 425
struct mm_struct;
#line 426
struct task_struct;
#line 427
struct cpumask;
#line 20 "./arch/x86/include/asm/spinlock_types.h"
struct qspinlock {
   atomic_t val ;
};
#line 33 "include/asm-generic/qspinlock_types.h"
typedef struct qspinlock arch_spinlock_t;
#line 131 "include/linux/init.h"
typedef void (*ctor_fn_t)(void);
#line 48 "include/linux/dynamic_debug.h"
struct device;
#line 432 "include/linux/printk.h"
struct completion;
#line 687 "include/linux/list.h"
struct lockdep_map;
#line 328 "include/linux/bitmap.h"
struct bug_entry {
   int bug_addr_disp ;
   int file_disp ;
   unsigned short line ;
   unsigned short flags ;
};
#line 102 "include/linux/bug.h"
struct cpumask {
   unsigned long bits[128U] ;
};
#line 652 "include/linux/cpumask.h"
typedef struct cpumask *cpumask_var_t;
#line 170 "./arch/x86/include/asm/processor.h"
struct seq_operations;
#line 23 "include/asm-generic/atomic-long.h"
typedef atomic64_t atomic_long_t;
#line 55 "include/linux/debug_locks.h"
struct stack_trace {
   unsigned int nr_entries ;
   unsigned int max_entries ;
   unsigned long *entries ;
   int skip ;
};
#line 28 "include/linux/stacktrace.h"
struct lockdep_subclass_key {
   char __one_byte ;
};
#line 53 "include/linux/lockdep.h"
struct lock_class_key {
   struct lockdep_subclass_key subkeys[8U] ;
};
#line 59 "include/linux/lockdep.h"
struct lock_class {
   struct list_head hash_entry ;
   struct list_head lock_entry ;
   struct lockdep_subclass_key *key ;
   unsigned int subclass ;
   unsigned int dep_gen_id ;
   unsigned long usage_mask ;
   struct stack_trace usage_traces[13U] ;
   struct list_head locks_after ;
   struct list_head locks_before ;
   unsigned int version ;
   unsigned long ops ;
   char const   *name ;
   int name_version ;
   unsigned long contention_point[4U] ;
   unsigned long contending_point[4U] ;
};
#line 144 "include/linux/lockdep.h"
struct lockdep_map {
   struct lock_class_key *key ;
   struct lock_class *class_cache[2U] ;
   char const   *name ;
   int cpu ;
   unsigned long ip ;
};
#line 546 "include/linux/lockdep.h"
struct raw_spinlock {
   arch_spinlock_t raw_lock ;
   unsigned int magic ;
   unsigned int owner_cpu ;
   void *owner ;
   struct lockdep_map dep_map ;
};
#line 32 "include/linux/spinlock_types.h"
typedef struct raw_spinlock raw_spinlock_t;
#line 33 "include/linux/spinlock_types.h"
struct __anonstruct____missing_field_name_31 {
   u8 __padding[24U] ;
   struct lockdep_map dep_map ;
};
#line 33 "include/linux/spinlock_types.h"
union __anonunion____missing_field_name_30 {
   struct raw_spinlock rlock ;
   struct __anonstruct____missing_field_name_31 __annonCompField16 ;
};
#line 33 "include/linux/spinlock_types.h"
struct spinlock {
   union __anonunion____missing_field_name_30 __annonCompField17 ;
};
#line 76 "include/linux/spinlock_types.h"
typedef struct spinlock spinlock_t;
#line 13 "include/linux/osq_lock.h"
struct optimistic_spin_queue {
   atomic_t tail ;
};
#line 39 "include/linux/osq_lock.h"
struct mutex {
   atomic_t count ;
   spinlock_t wait_lock ;
   struct list_head wait_list ;
   struct task_struct *owner ;
   void *magic ;
   struct lockdep_map dep_map ;
};
#line 53 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.o.c.prepared"
struct resource {
   resource_size_t start ;
   resource_size_t end ;
   char const   *name ;
   unsigned long flags ;
   struct resource *parent ;
   struct resource *sibling ;
   struct resource *child ;
};
#line 38 "include/linux/wait.h"
struct __wait_queue_head {
   spinlock_t lock ;
   struct list_head task_list ;
};
#line 43 "include/linux/wait.h"
typedef struct __wait_queue_head wait_queue_head_t;
#line 1170 "include/linux/wait.h"
struct completion {
   unsigned int done ;
   wait_queue_head_t wait ;
};
#line 437 "include/linux/jiffies.h"
union ktime {
   s64 tv64 ;
};
#line 41 "include/linux/ktime.h"
typedef union ktime ktime_t;
#line 1120 "include/linux/rcupdate.h"
union __anonunion____missing_field_name_46 {
   unsigned long bitmap[4U] ;
   struct callback_head callback_head ;
};
#line 1120 "include/linux/rcupdate.h"
struct idr_layer {
   int prefix ;
   int layer ;
   struct idr_layer *ary[256U] ;
   int count ;
   union __anonunion____missing_field_name_46 __annonCompField19 ;
};
#line 41 "include/linux/idr.h"
struct idr {
   struct idr_layer *hint ;
   struct idr_layer *top ;
   int layers ;
   int cur ;
   spinlock_t lock ;
   int id_free_cnt ;
   struct idr_layer *id_free ;
};
#line 124 "include/linux/idr.h"
struct ida_bitmap {
   long nr_busy ;
   unsigned long bitmap[15U] ;
};
#line 153 "include/linux/idr.h"
struct ida {
   struct idr idr ;
   struct ida_bitmap *free_bitmap ;
};
#line 185 "include/linux/idr.h"
struct rb_node {
   unsigned long __rb_parent_color ;
   struct rb_node *rb_right ;
   struct rb_node *rb_left ;
};
#line 41 "include/linux/rbtree.h"
struct rb_root {
   struct rb_node *rb_node ;
};
#line 99
struct vm_area_struct;
#line 102
struct kernfs_open_node;
#line 103
struct kernfs_iattrs;
#line 126
struct kernfs_root;
#line 126 "include/linux/rbtree.h"
struct kernfs_elem_dir {
   unsigned long subdirs ;
   struct rb_root children ;
   struct kernfs_root *root ;
};
#line 85 "include/linux/kernfs.h"
struct kernfs_node;
#line 85 "include/linux/kernfs.h"
struct kernfs_elem_symlink {
   struct kernfs_node *target_kn ;
};
#line 89
struct kernfs_ops;
#line 89 "include/linux/kernfs.h"
struct kernfs_elem_attr {
   struct kernfs_ops  const  *ops ;
   struct kernfs_open_node *open ;
   loff_t size ;
   struct kernfs_node *notify_next ;
};
#line 96 "include/linux/kernfs.h"
union __anonunion____missing_field_name_51 {
   struct kernfs_elem_dir dir ;
   struct kernfs_elem_symlink symlink ;
   struct kernfs_elem_attr attr ;
};
#line 96 "include/linux/kernfs.h"
struct kernfs_node {
   atomic_t count ;
   atomic_t active ;
   struct lockdep_map dep_map ;
   struct kernfs_node *parent ;
   char const   *name ;
   struct rb_node rb ;
   void const   *ns ;
   unsigned int hash ;
   union __anonunion____missing_field_name_51 __annonCompField20 ;
   void *priv ;
   unsigned short flags ;
   umode_t mode ;
   unsigned int ino ;
   struct kernfs_iattrs *iattr ;
};
#line 138 "include/linux/kernfs.h"
struct kernfs_syscall_ops {
   int (*remount_fs)(struct kernfs_root * , int * , char * ) ;
   int (*show_options)(struct seq_file * , struct kernfs_root * ) ;
   int (*mkdir)(struct kernfs_node * , char const   * , umode_t  ) ;
   int (*rmdir)(struct kernfs_node * ) ;
   int (*rename)(struct kernfs_node * , struct kernfs_node * , char const   * ) ;
};
#line 155 "include/linux/kernfs.h"
struct kernfs_root {
   struct kernfs_node *kn ;
   unsigned int flags ;
   struct ida ino_ida ;
   struct kernfs_syscall_ops *syscall_ops ;
   struct list_head supers ;
   wait_queue_head_t deactivate_waitq ;
};
#line 171
struct vm_operations_struct;
#line 171 "include/linux/kernfs.h"
struct kernfs_open_file {
   struct kernfs_node *kn ;
   struct file *file ;
   void *priv ;
   struct mutex mutex ;
   int event ;
   struct list_head list ;
   char *prealloc_buf ;
   size_t atomic_write_len ;
   bool mmapped ;
   struct vm_operations_struct  const  *vm_ops ;
};
#line 188 "include/linux/kernfs.h"
struct kernfs_ops {
   int (*seq_show)(struct seq_file * , void * ) ;
   void *(*seq_start)(struct seq_file * , loff_t * ) ;
   void *(*seq_next)(struct seq_file * , void * , loff_t * ) ;
   void (*seq_stop)(struct seq_file * , void * ) ;
   ssize_t (*read)(struct kernfs_open_file * , char * , size_t  , loff_t  ) ;
   size_t atomic_write_len ;
   bool prealloc ;
   ssize_t (*write)(struct kernfs_open_file * , char * , size_t  , loff_t  ) ;
   int (*mmap)(struct kernfs_open_file * , struct vm_area_struct * ) ;
   struct lock_class_key lockdep_key ;
};
#line 477
struct sock;
#line 478
struct kobject;
#line 479
enum kobj_ns_type {
    KOBJ_NS_TYPE_NONE = 0,
    KOBJ_NS_TYPE_NET = 1,
    KOBJ_NS_TYPES = 2
} ;
#line 485 "include/linux/kernfs.h"
struct kobj_ns_type_operations {
   enum kobj_ns_type type ;
   bool (*current_may_mount)(void) ;
   void *(*grab_current_ns)(void) ;
   void const   *(*netlink_ns)(struct sock * ) ;
   void const   *(*initial_ns)(void) ;
   void (*drop_ns)(void * ) ;
};
#line 83 "include/linux/highuid.h"
struct user_namespace;
#line 22 "include/linux/uidgid.h"
struct __anonstruct_kuid_t_52 {
   uid_t val ;
};
#line 22 "include/linux/uidgid.h"
typedef struct __anonstruct_kuid_t_52 kuid_t;
#line 27 "include/linux/uidgid.h"
struct __anonstruct_kgid_t_53 {
   gid_t val ;
};
#line 27 "include/linux/uidgid.h"
typedef struct __anonstruct_kgid_t_53 kgid_t;
#line 36 "include/linux/stat.h"
struct bin_attribute;
#line 37 "include/linux/stat.h"
struct attribute {
   char const   *name ;
   umode_t mode ;
   bool ignore_lockdep ;
   struct lock_class_key *key ;
   struct lock_class_key skey ;
};
#line 37 "include/linux/sysfs.h"
struct attribute_group {
   char const   *name ;
   umode_t (*is_visible)(struct kobject * , struct attribute * , int  ) ;
   struct attribute **attrs ;
   struct bin_attribute **bin_attrs ;
};
#line 82 "include/linux/sysfs.h"
struct bin_attribute {
   struct attribute attr ;
   size_t size ;
   void *private ;
   ssize_t (*read)(struct file * , struct kobject * , struct bin_attribute * , char * ,
                   loff_t  , size_t  ) ;
   ssize_t (*write)(struct file * , struct kobject * , struct bin_attribute * , char * ,
                    loff_t  , size_t  ) ;
   int (*mmap)(struct file * , struct kobject * , struct bin_attribute * , struct vm_area_struct * ) ;
};
#line 155 "include/linux/sysfs.h"
struct sysfs_ops {
   ssize_t (*show)(struct kobject * , struct attribute * , char * ) ;
   ssize_t (*store)(struct kobject * , struct attribute * , char const   * , size_t  ) ;
};
#line 509 "include/linux/sysfs.h"
struct kref {
   atomic_t refcount ;
};
#line 172 "include/linux/kref.h"
struct timer_list {
   struct hlist_node entry ;
   unsigned long expires ;
   void (*function)(unsigned long  ) ;
   unsigned long data ;
   u32 flags ;
   int slack ;
   int start_pid ;
   void *start_site ;
   char start_comm[16U] ;
   struct lockdep_map lockdep_map ;
};
#line 259 "include/linux/timer.h"
struct workqueue_struct;
#line 260
struct work_struct;
#line 54 "include/linux/workqueue.h"
struct work_struct {
   atomic_long_t data ;
   struct list_head entry ;
   void (*func)(struct work_struct * ) ;
   struct lockdep_map lockdep_map ;
};
#line 107 "include/linux/workqueue.h"
struct delayed_work {
   struct work_struct work ;
   struct timer_list timer ;
   struct workqueue_struct *wq ;
   int cpu ;
};
#line 52 "include/linux/kobject.h"
struct kset;
#line 52
struct kobj_type;
#line 52 "include/linux/kobject.h"
struct kobject {
   char const   *name ;
   struct list_head entry ;
   struct kobject *parent ;
   struct kset *kset ;
   struct kobj_type *ktype ;
   struct kernfs_node *sd ;
   struct kref kref ;
   struct delayed_work release ;
   unsigned char state_initialized : 1 ;
   unsigned char state_in_sysfs : 1 ;
   unsigned char state_add_uevent_sent : 1 ;
   unsigned char state_remove_uevent_sent : 1 ;
   unsigned char uevent_suppress : 1 ;
};
#line 114 "include/linux/kobject.h"
struct kobj_type {
   void (*release)(struct kobject * ) ;
   struct sysfs_ops  const  *sysfs_ops ;
   struct attribute **default_attrs ;
   struct kobj_ns_type_operations  const  *(*child_ns_type)(struct kobject * ) ;
   void const   *(*namespace)(struct kobject * ) ;
};
#line 122 "include/linux/kobject.h"
struct kobj_uevent_env {
   char *argv[3U] ;
   char *envp[32U] ;
   int envp_idx ;
   char buf[2048U] ;
   int buflen ;
};
#line 130 "include/linux/kobject.h"
struct kset_uevent_ops {
   int (* const  filter)(struct kset * , struct kobject * ) ;
   char const   *(* const  name)(struct kset * , struct kobject * ) ;
   int (* const  uevent)(struct kset * , struct kobject * , struct kobj_uevent_env * ) ;
};
#line 147 "include/linux/kobject.h"
struct kset {
   struct list_head list ;
   spinlock_t list_lock ;
   struct kobject kobj ;
   struct kset_uevent_ops  const  *uevent_ops ;
};
#line 222
struct klist_node;
#line 37 "include/linux/klist.h"
struct klist_node {
   void *n_klist ;
   struct list_head n_node ;
   struct kref n_ref ;
};
#line 521 "include/linux/nodemask.h"
struct seq_file {
   char *buf ;
   size_t size ;
   size_t from ;
   size_t count ;
   size_t pad_until ;
   loff_t index ;
   loff_t read_pos ;
   u64 version ;
   struct mutex lock ;
   struct seq_operations  const  *op ;
   int poll_event ;
   struct user_namespace *user_ns ;
   void *private ;
};
#line 35 "include/linux/seq_file.h"
struct seq_operations {
   void *(*start)(struct seq_file * , loff_t * ) ;
   void (*stop)(struct seq_file * , void * ) ;
   void *(*next)(struct seq_file * , void * , loff_t * ) ;
   int (*show)(struct seq_file * , void * ) ;
};
#line 187
struct pinctrl;
#line 188
struct pinctrl_state;
#line 194 "include/linux/pinctrl/consumer.h"
struct dev_pin_info {
   struct pinctrl *p ;
   struct pinctrl_state *default_state ;
   struct pinctrl_state *sleep_state ;
   struct pinctrl_state *idle_state ;
};
#line 58 "include/linux/pm.h"
struct pm_message {
   int event ;
};
#line 64 "include/linux/pm.h"
typedef struct pm_message pm_message_t;
#line 65 "include/linux/pm.h"
struct dev_pm_ops {
   int (*prepare)(struct device * ) ;
   void (*complete)(struct device * ) ;
   int (*suspend)(struct device * ) ;
   int (*resume)(struct device * ) ;
   int (*freeze)(struct device * ) ;
   int (*thaw)(struct device * ) ;
   int (*poweroff)(struct device * ) ;
   int (*restore)(struct device * ) ;
   int (*suspend_late)(struct device * ) ;
   int (*resume_early)(struct device * ) ;
   int (*freeze_late)(struct device * ) ;
   int (*thaw_early)(struct device * ) ;
   int (*poweroff_late)(struct device * ) ;
   int (*restore_early)(struct device * ) ;
   int (*suspend_noirq)(struct device * ) ;
   int (*resume_noirq)(struct device * ) ;
   int (*freeze_noirq)(struct device * ) ;
   int (*thaw_noirq)(struct device * ) ;
   int (*poweroff_noirq)(struct device * ) ;
   int (*restore_noirq)(struct device * ) ;
   int (*runtime_suspend)(struct device * ) ;
   int (*runtime_resume)(struct device * ) ;
   int (*runtime_idle)(struct device * ) ;
};
#line 320
enum rpm_status {
    RPM_ACTIVE = 0,
    RPM_RESUMING = 1,
    RPM_SUSPENDED = 2,
    RPM_SUSPENDING = 3
} ;
#line 327
enum rpm_request {
    RPM_REQ_NONE = 0,
    RPM_REQ_IDLE = 1,
    RPM_REQ_SUSPEND = 2,
    RPM_REQ_AUTOSUSPEND = 3,
    RPM_REQ_RESUME = 4
} ;
#line 335
struct wakeup_source;
#line 336
struct wake_irq;
#line 338 "include/linux/pm.h"
struct pm_subsys_data {
   spinlock_t lock ;
   unsigned int refcount ;
   struct list_head clock_list ;
};
#line 553
struct dev_pm_qos;
#line 553 "include/linux/pm.h"
struct dev_pm_info {
   pm_message_t power_state ;
   unsigned char can_wakeup : 1 ;
   unsigned char async_suspend : 1 ;
   bool is_prepared ;
   bool is_suspended ;
   bool is_noirq_suspended ;
   bool is_late_suspended ;
   bool ignore_children ;
   bool early_init ;
   bool direct_complete ;
   spinlock_t lock ;
   struct list_head entry ;
   struct completion completion ;
   struct wakeup_source *wakeup ;
   bool wakeup_path ;
   bool syscore ;
   struct timer_list suspend_timer ;
   unsigned long timer_expires ;
   struct work_struct work ;
   wait_queue_head_t wait_queue ;
   struct wake_irq *wakeirq ;
   atomic_t usage_count ;
   atomic_t child_count ;
   unsigned char disable_depth : 3 ;
   unsigned char idle_notification : 1 ;
   unsigned char request_pending : 1 ;
   unsigned char deferred_resume : 1 ;
   unsigned char run_wake : 1 ;
   unsigned char runtime_auto : 1 ;
   unsigned char no_callbacks : 1 ;
   unsigned char irq_safe : 1 ;
   unsigned char use_autosuspend : 1 ;
   unsigned char timer_autosuspends : 1 ;
   unsigned char memalloc_noio : 1 ;
   enum rpm_request request ;
   enum rpm_status runtime_status ;
   int runtime_error ;
   int autosuspend_delay ;
   unsigned long last_busy ;
   unsigned long active_jiffies ;
   unsigned long suspended_jiffies ;
   unsigned long accounting_timestamp ;
   struct pm_subsys_data *subsys_data ;
   void (*set_latency_tolerance)(struct device * , s32  ) ;
   struct dev_pm_qos *qos ;
};
#line 615 "include/linux/pm.h"
struct dev_pm_domain {
   struct dev_pm_ops ops ;
   void (*detach)(struct device * , bool  ) ;
   int (*activate)(struct device * ) ;
   void (*sync)(struct device * ) ;
   void (*dismiss)(struct device * ) ;
};
#line 796 "include/linux/mmzone.h"
struct rw_semaphore;
#line 797 "include/linux/mmzone.h"
struct rw_semaphore {
   long count ;
   struct list_head wait_list ;
   raw_spinlock_t wait_lock ;
   struct optimistic_spin_queue osq ;
   struct task_struct *owner ;
   struct lockdep_map dep_map ;
};
#line 24 "./arch/x86/include/asm/mmu.h"
struct __anonstruct_mm_context_t_121 {
   void *ldt ;
   int size ;
   unsigned short ia32_compat ;
   struct mutex lock ;
   void *vdso ;
   atomic_t perf_rdpmc_allowed ;
};
#line 24 "./arch/x86/include/asm/mmu.h"
typedef struct __anonstruct_mm_context_t_121 mm_context_t;
#line 428 "include/linux/gfp.h"
struct dma_map_ops;
#line 428 "include/linux/gfp.h"
struct dev_archdata {
   struct dma_map_ops *dma_ops ;
   void *iommu ;
};
#line 11 "./arch/x86/include/asm/device.h"
struct pdev_archdata {

};
#line 14
struct device_private;
#line 15
struct device_driver;
#line 16
struct driver_private;
#line 17
struct class;
#line 18
struct subsys_private;
#line 19
struct bus_type;
#line 20
struct device_node;
#line 21
struct fwnode_handle;
#line 22
struct iommu_ops;
#line 23
struct iommu_group;
#line 61 "include/linux/device.h"
struct device_attribute;
#line 61 "include/linux/device.h"
struct bus_type {
   char const   *name ;
   char const   *dev_name ;
   struct device *dev_root ;
   struct device_attribute *dev_attrs ;
   struct attribute_group  const  **bus_groups ;
   struct attribute_group  const  **dev_groups ;
   struct attribute_group  const  **drv_groups ;
   int (*match)(struct device * , struct device_driver * ) ;
   int (*uevent)(struct device * , struct kobj_uevent_env * ) ;
   int (*probe)(struct device * ) ;
   int (*remove)(struct device * ) ;
   void (*shutdown)(struct device * ) ;
   int (*online)(struct device * ) ;
   int (*offline)(struct device * ) ;
   int (*suspend)(struct device * , pm_message_t  ) ;
   int (*resume)(struct device * ) ;
   struct dev_pm_ops  const  *pm ;
   struct iommu_ops  const  *iommu_ops ;
   struct subsys_private *p ;
   struct lock_class_key lock_key ;
};
#line 139
struct device_type;
#line 197
enum probe_type {
    PROBE_DEFAULT_STRATEGY = 0,
    PROBE_PREFER_ASYNCHRONOUS = 1,
    PROBE_FORCE_SYNCHRONOUS = 2
} ;
#line 203
struct of_device_id;
#line 203
struct acpi_device_id;
#line 203 "include/linux/device.h"
struct device_driver {
   char const   *name ;
   struct bus_type *bus ;
   struct module *owner ;
   char const   *mod_name ;
   bool suppress_bind_attrs ;
   enum probe_type probe_type ;
   struct of_device_id  const  *of_match_table ;
   struct acpi_device_id  const  *acpi_match_table ;
   int (*probe)(struct device * ) ;
   int (*remove)(struct device * ) ;
   void (*shutdown)(struct device * ) ;
   int (*suspend)(struct device * , pm_message_t  ) ;
   int (*resume)(struct device * ) ;
   struct attribute_group  const  **groups ;
   struct dev_pm_ops  const  *pm ;
   struct driver_private *p ;
};
#line 353
struct class_attribute;
#line 353 "include/linux/device.h"
struct class {
   char const   *name ;
   struct module *owner ;
   struct class_attribute *class_attrs ;
   struct attribute_group  const  **dev_groups ;
   struct kobject *dev_kobj ;
   int (*dev_uevent)(struct device * , struct kobj_uevent_env * ) ;
   char *(*devnode)(struct device * , umode_t * ) ;
   void (*class_release)(struct class * ) ;
   void (*dev_release)(struct device * ) ;
   int (*suspend)(struct device * , pm_message_t  ) ;
   int (*resume)(struct device * ) ;
   struct kobj_ns_type_operations  const  *ns_type ;
   void const   *(*namespace)(struct device * ) ;
   struct dev_pm_ops  const  *pm ;
   struct subsys_private *p ;
};
#line 446 "include/linux/device.h"
struct class_attribute {
   struct attribute attr ;
   ssize_t (*show)(struct class * , struct class_attribute * , char * ) ;
   ssize_t (*store)(struct class * , struct class_attribute * , char const   * , size_t  ) ;
};
#line 514 "include/linux/device.h"
struct device_type {
   char const   *name ;
   struct attribute_group  const  **groups ;
   int (*uevent)(struct device * , struct kobj_uevent_env * ) ;
   char *(*devnode)(struct device * , umode_t * , kuid_t * , kgid_t * ) ;
   void (*release)(struct device * ) ;
   struct dev_pm_ops  const  *pm ;
};
#line 542 "include/linux/device.h"
struct device_attribute {
   struct attribute attr ;
   ssize_t (*show)(struct device * , struct device_attribute * , char * ) ;
   ssize_t (*store)(struct device * , struct device_attribute * , char const   * ,
                    size_t  ) ;
};
#line 674 "include/linux/device.h"
struct device_dma_parameters {
   unsigned int max_segment_size ;
   unsigned long segment_boundary_mask ;
};
#line 683
struct dma_coherent_mem;
#line 683
struct cma;
#line 683 "include/linux/device.h"
struct device {
   struct device *parent ;
   struct device_private *p ;
   struct kobject kobj ;
   char const   *init_name ;
   struct device_type  const  *type ;
   struct mutex mutex ;
   struct bus_type *bus ;
   struct device_driver *driver ;
   void *platform_data ;
   void *driver_data ;
   struct dev_pm_info power ;
   struct dev_pm_domain *pm_domain ;
   struct dev_pin_info *pins ;
   int numa_node ;
   u64 *dma_mask ;
   u64 coherent_dma_mask ;
   unsigned long dma_pfn_offset ;
   struct device_dma_parameters *dma_parms ;
   struct list_head dma_pools ;
   struct dma_coherent_mem *dma_mem ;
   struct cma *cma_area ;
   struct dev_archdata archdata ;
   struct device_node *of_node ;
   struct fwnode_handle *fwnode ;
   dev_t devt ;
   u32 id ;
   spinlock_t devres_lock ;
   struct list_head devres_head ;
   struct klist_node knode_class ;
   struct class *class ;
   struct attribute_group  const  **groups ;
   void (*release)(struct device * ) ;
   struct iommu_group *iommu_group ;
   bool offline_disabled ;
   bool offline ;
};
#line 829 "include/linux/device.h"
struct wakeup_source {
   char const   *name ;
   struct list_head entry ;
   spinlock_t lock ;
   struct wake_irq *wakeirq ;
   struct timer_list timer ;
   unsigned long timer_expires ;
   ktime_t total_time ;
   ktime_t max_time ;
   ktime_t last_time ;
   ktime_t start_prevent_time ;
   ktime_t prevent_sleep_time ;
   unsigned long event_count ;
   unsigned long active_count ;
   unsigned long relax_count ;
   unsigned long expire_count ;
   unsigned long wakeup_count ;
   bool active ;
   bool autosleep_enabled ;
};
#line 1273
enum irqreturn {
    IRQ_NONE = 0,
    IRQ_HANDLED = 1,
    IRQ_WAKE_THREAD = 2
} ;
#line 16 "include/linux/irqreturn.h"
typedef enum irqreturn irqreturn_t;
#line 62 "./arch/x86/include/asm/uaccess.h"
struct exception_table_entry {
   int insn ;
   int fixup ;
};
#line 13 "include/linux/mod_devicetable.h"
typedef unsigned long kernel_ulong_t;
#line 186 "include/linux/mod_devicetable.h"
struct acpi_device_id {
   __u8 id[9U] ;
   kernel_ulong_t driver_data ;
};
#line 219 "include/linux/mod_devicetable.h"
struct of_device_id {
   char name[32U] ;
   char type[32U] ;
   char compatible[128U] ;
   void const   *data ;
};
#line 474 "include/linux/mod_devicetable.h"
struct platform_device_id {
   char name[20U] ;
   kernel_ulong_t driver_data ;
};
#line 650
enum fwnode_type {
    FWNODE_INVALID = 0,
    FWNODE_OF = 1,
    FWNODE_ACPI = 2,
    FWNODE_PDATA = 3
} ;
#line 657 "include/linux/mod_devicetable.h"
struct fwnode_handle {
   enum fwnode_type type ;
   struct fwnode_handle *secondary ;
};
#line 32 "include/linux/of.h"
typedef u32 phandle;
#line 34 "include/linux/of.h"
struct property {
   char *name ;
   int length ;
   void *value ;
   struct property *next ;
   unsigned long _flags ;
   unsigned int unique_id ;
   struct bin_attribute attr ;
};
#line 44 "include/linux/of.h"
struct device_node {
   char const   *name ;
   char const   *type ;
   phandle phandle ;
   char const   *full_name ;
   struct fwnode_handle fwnode ;
   struct property *properties ;
   struct property *deadprops ;
   struct device_node *parent ;
   struct device_node *child ;
   struct device_node *sibling ;
   struct kobject kobj ;
   unsigned long _flags ;
   void *data ;
};
#line 65 "include/linux/of.h"
struct of_phandle_args {
   struct device_node *np ;
   int args_count ;
   uint32_t args[16U] ;
};
#line 1084
struct mbox_chan;
#line 1085 "include/linux/of.h"
struct mbox_chan_ops {
   int (*send_data)(struct mbox_chan * , void * ) ;
   int (*startup)(struct mbox_chan * ) ;
   void (*shutdown)(struct mbox_chan * ) ;
   bool (*last_tx_done)(struct mbox_chan * ) ;
   bool (*peek_data)(struct mbox_chan * ) ;
};
#line 54 "include/linux/mailbox_controller.h"
struct mbox_controller {
   struct device *dev ;
   struct mbox_chan_ops  const  *ops ;
   struct mbox_chan *chans ;
   int num_chans ;
   bool txdone_irq ;
   bool txdone_poll ;
   unsigned int txpoll_period ;
   struct mbox_chan *(*of_xlate)(struct mbox_controller * , struct of_phandle_args  const  * ) ;
   struct timer_list poll ;
   struct list_head node ;
};
#line 87
struct mbox_client;
#line 87 "include/linux/mailbox_controller.h"
struct mbox_chan {
   struct mbox_controller *mbox ;
   unsigned int txdone_method ;
   struct mbox_client *cl ;
   struct completion tx_complete ;
   void *active_req ;
   unsigned int msg_count ;
   unsigned int msg_free ;
   void *msg_data[20U] ;
   spinlock_t lock ;
   void *con_priv ;
};
#line 94 "include/linux/uprobes.h"
struct xol_area;
#line 95 "include/linux/uprobes.h"
struct uprobes_state {
   struct xol_area *xol_area ;
};
#line 266 "include/linux/mm_types.h"
struct __anonstruct_shared_179 {
   struct rb_node rb ;
   unsigned long rb_subtree_last ;
};
#line 266
struct anon_vma;
#line 266
struct mempolicy;
#line 266 "include/linux/mm_types.h"
struct vm_area_struct {
   unsigned long vm_start ;
   unsigned long vm_end ;
   struct vm_area_struct *vm_next ;
   struct vm_area_struct *vm_prev ;
   struct rb_node vm_rb ;
   unsigned long rb_subtree_gap ;
   struct mm_struct *vm_mm ;
   pgprot_t vm_page_prot ;
   unsigned long vm_flags ;
   struct __anonstruct_shared_179 shared ;
   struct list_head anon_vma_chain ;
   struct anon_vma *anon_vma ;
   struct vm_operations_struct  const  *vm_ops ;
   unsigned long vm_pgoff ;
   struct file *vm_file ;
   void *vm_private_data ;
   struct mempolicy *vm_policy ;
};
#line 334 "include/linux/mm_types.h"
struct core_thread {
   struct task_struct *task ;
   struct core_thread *next ;
};
#line 340 "include/linux/mm_types.h"
struct core_state {
   atomic_t nr_threads ;
   struct core_thread dumper ;
   struct completion startup ;
};
#line 361 "include/linux/mm_types.h"
struct mm_rss_stat {
   atomic_long_t count[3U] ;
};
#line 366
struct kioctx_table;
#line 367
struct linux_binfmt;
#line 367
struct mmu_notifier_mm;
#line 367 "include/linux/mm_types.h"
struct mm_struct {
   struct vm_area_struct *mmap ;
   struct rb_root mm_rb ;
   u32 vmacache_seqnum ;
   unsigned long (*get_unmapped_area)(struct file * , unsigned long  , unsigned long  ,
                                      unsigned long  , unsigned long  ) ;
   unsigned long mmap_base ;
   unsigned long mmap_legacy_base ;
   unsigned long task_size ;
   unsigned long highest_vm_end ;
   pgd_t *pgd ;
   atomic_t mm_users ;
   atomic_t mm_count ;
   atomic_long_t nr_ptes ;
   atomic_long_t nr_pmds ;
   int map_count ;
   spinlock_t page_table_lock ;
   struct rw_semaphore mmap_sem ;
   struct list_head mmlist ;
   unsigned long hiwater_rss ;
   unsigned long hiwater_vm ;
   unsigned long total_vm ;
   unsigned long locked_vm ;
   unsigned long pinned_vm ;
   unsigned long shared_vm ;
   unsigned long exec_vm ;
   unsigned long stack_vm ;
   unsigned long def_flags ;
   unsigned long start_code ;
   unsigned long end_code ;
   unsigned long start_data ;
   unsigned long end_data ;
   unsigned long start_brk ;
   unsigned long brk ;
   unsigned long start_stack ;
   unsigned long arg_start ;
   unsigned long arg_end ;
   unsigned long env_start ;
   unsigned long env_end ;
   unsigned long saved_auxv[46U] ;
   struct mm_rss_stat rss_stat ;
   struct linux_binfmt *binfmt ;
   cpumask_var_t cpu_vm_mask_var ;
   mm_context_t context ;
   unsigned long flags ;
   struct core_state *core_state ;
   spinlock_t ioctx_lock ;
   struct kioctx_table *ioctx_table ;
   struct task_struct *owner ;
   struct file *exe_file ;
   struct mmu_notifier_mm *mmu_notifier_mm ;
   struct cpumask cpumask_allocation ;
   unsigned long numa_next_scan ;
   unsigned long numa_scan_offset ;
   int numa_scan_seq ;
   bool tlb_flush_pending ;
   struct uprobes_state uprobes_state ;
   void *bd_addr ;
};
#line 15 "include/uapi/linux/elf.h"
typedef __u64 Elf64_Addr;
#line 16 "include/uapi/linux/elf.h"
typedef __u16 Elf64_Half;
#line 20 "include/uapi/linux/elf.h"
typedef __u32 Elf64_Word;
#line 21 "include/uapi/linux/elf.h"
typedef __u64 Elf64_Xword;
#line 190 "include/uapi/linux/elf.h"
struct elf64_sym {
   Elf64_Word st_name ;
   unsigned char st_info ;
   unsigned char st_other ;
   Elf64_Half st_shndx ;
   Elf64_Addr st_value ;
   Elf64_Xword st_size ;
};
#line 198 "include/uapi/linux/elf.h"
typedef struct elf64_sym Elf64_Sym;
#line 53 "include/linux/elf.h"
struct kernel_param;
#line 58 "include/linux/elf.h"
struct kernel_param_ops {
   unsigned int flags ;
   int (*set)(char const   * , struct kernel_param  const  * ) ;
   int (*get)(char * , struct kernel_param  const  * ) ;
   void (*free)(void * ) ;
};
#line 62 "include/linux/moduleparam.h"
struct kparam_string;
#line 62
struct kparam_array;
#line 62 "include/linux/moduleparam.h"
union __anonunion____missing_field_name_184 {
   void *arg ;
   struct kparam_string  const  *str ;
   struct kparam_array  const  *arr ;
};
#line 62 "include/linux/moduleparam.h"
struct kernel_param {
   char const   *name ;
   struct module *mod ;
   struct kernel_param_ops  const  *ops ;
   u16 const   perm ;
   s8 level ;
   u8 flags ;
   union __anonunion____missing_field_name_184 __annonCompField56 ;
};
#line 83 "include/linux/moduleparam.h"
struct kparam_string {
   unsigned int maxlen ;
   char *string ;
};
#line 89 "include/linux/moduleparam.h"
struct kparam_array {
   unsigned int max ;
   unsigned int elemsize ;
   unsigned int *num ;
   struct kernel_param_ops  const  *ops ;
   void *elem ;
};
#line 469 "include/linux/moduleparam.h"
struct latch_tree_node {
   struct rb_node node[2U] ;
};
#line 211 "include/linux/rbtree_latch.h"
struct mod_arch_specific {

};
#line 37 "include/linux/module.h"
struct module_param_attrs;
#line 37 "include/linux/module.h"
struct module_kobject {
   struct kobject kobj ;
   struct module *mod ;
   struct kobject *drivers_dir ;
   struct module_param_attrs *mp ;
   struct completion *kobj_completion ;
};
#line 47 "include/linux/module.h"
struct module_attribute {
   struct attribute attr ;
   ssize_t (*show)(struct module_attribute * , struct module_kobject * , char * ) ;
   ssize_t (*store)(struct module_attribute * , struct module_kobject * , char const   * ,
                    size_t  ) ;
   void (*setup)(struct module * , char const   * ) ;
   int (*test)(struct module * ) ;
   void (*free)(struct module * ) ;
};
#line 206
enum module_state {
    MODULE_STATE_LIVE = 0,
    MODULE_STATE_COMING = 1,
    MODULE_STATE_GOING = 2,
    MODULE_STATE_UNFORMED = 3
} ;
#line 213 "include/linux/module.h"
struct mod_tree_node {
   struct module *mod ;
   struct latch_tree_node node ;
};
#line 220
struct module_sect_attrs;
#line 220
struct module_notes_attrs;
#line 220
struct tracepoint;
#line 220
struct trace_event_call;
#line 220
struct trace_enum_map;
#line 220 "include/linux/module.h"
struct module {
   enum module_state state ;
   struct list_head list ;
   char name[56U] ;
   struct module_kobject mkobj ;
   struct module_attribute *modinfo_attrs ;
   char const   *version ;
   char const   *srcversion ;
   struct kobject *holders_dir ;
   struct kernel_symbol  const  *syms ;
   unsigned long const   *crcs ;
   unsigned int num_syms ;
   struct mutex param_lock ;
   struct kernel_param *kp ;
   unsigned int num_kp ;
   unsigned int num_gpl_syms ;
   struct kernel_symbol  const  *gpl_syms ;
   unsigned long const   *gpl_crcs ;
   struct kernel_symbol  const  *unused_syms ;
   unsigned long const   *unused_crcs ;
   unsigned int num_unused_syms ;
   unsigned int num_unused_gpl_syms ;
   struct kernel_symbol  const  *unused_gpl_syms ;
   unsigned long const   *unused_gpl_crcs ;
   bool sig_ok ;
   bool async_probe_requested ;
   struct kernel_symbol  const  *gpl_future_syms ;
   unsigned long const   *gpl_future_crcs ;
   unsigned int num_gpl_future_syms ;
   unsigned int num_exentries ;
   struct exception_table_entry *extable ;
   int (*init)(void) ;
   void *module_init ;
   void *module_core ;
   unsigned int init_size ;
   unsigned int core_size ;
   unsigned int init_text_size ;
   unsigned int core_text_size ;
   struct mod_tree_node mtn_core ;
   struct mod_tree_node mtn_init ;
   unsigned int init_ro_size ;
   unsigned int core_ro_size ;
   struct mod_arch_specific arch ;
   unsigned int taints ;
   unsigned int num_bugs ;
   struct list_head bug_list ;
   struct bug_entry *bug_table ;
   Elf64_Sym *symtab ;
   Elf64_Sym *core_symtab ;
   unsigned int num_symtab ;
   unsigned int core_num_syms ;
   char *strtab ;
   char *core_strtab ;
   struct module_sect_attrs *sect_attrs ;
   struct module_notes_attrs *notes_attrs ;
   char *args ;
   void *percpu ;
   unsigned int percpu_size ;
   unsigned int num_tracepoints ;
   struct tracepoint * const  *tracepoints_ptrs ;
   unsigned int num_trace_bprintk_fmt ;
   char const   **trace_bprintk_fmt_start ;
   struct trace_event_call **trace_events ;
   unsigned int num_trace_events ;
   struct trace_enum_map **trace_enums ;
   unsigned int num_trace_enums ;
   bool klp_alive ;
   struct list_head source_list ;
   struct list_head target_list ;
   void (*exit)(void) ;
   atomic_t refcnt ;
   ctor_fn_t (**ctors)(void) ;
   unsigned int num_ctors ;
};
#line 712
struct mfd_cell;
#line 713 "include/linux/module.h"
struct platform_device {
   char const   *name ;
   int id ;
   bool id_auto ;
   struct device dev ;
   u32 num_resources ;
   struct resource *resource ;
   struct platform_device_id  const  *id_entry ;
   char *driver_override ;
   struct mfd_cell *mfd_cell ;
   struct pdev_archdata archdata ;
};
#line 343 "include/linux/platform_device.h"
struct altera_mbox {
   bool is_sender ;
   bool intr_mode ;
   int irq ;
   void *mbox_base ;
   struct device *dev ;
   struct mbox_controller controller ;
   struct timer_list rxpoll_timer ;
};
#line 96 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.o.c.prepared"
typedef int ldv_func_ret_type;
#line 1 "<compiler builtins>"
__inline static long ldv__builtin_expect(long exp , long c ) ;
#line 3 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.o.c.prepared"
bool ldv_is_err(void const   *ptr ) ;
#line 6
long ldv_ptr_err(void const   *ptr ) ;
#line 32 "include/linux/err.h"
__inline static long PTR_ERR(void const   *ptr ) ;
#line 41
__inline static bool IS_ERR(void const   *ptr ) ;
#line 173 "include/linux/mutex.h"
extern int mutex_trylock(struct mutex * ) ;
#line 176
int ldv_mutex_trylock_8(struct mutex *ldv_func_arg1 ) ;
#line 178
extern void mutex_unlock(struct mutex * ) ;
#line 181
void ldv_mutex_unlock_6(struct mutex *ldv_func_arg1 ) ;
#line 185
void ldv_mutex_unlock_9(struct mutex *ldv_func_arg1 ) ;
#line 50 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static long ldv__builtin_expect(long exp , long c ) 
{ 


  {
#line 52
  return (exp);
}
}
#line 18 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.o.c.prepared"
extern void mutex_lock(struct mutex * ) ;
#line 21
void ldv_mutex_lock_5(struct mutex *ldv_func_arg1 ) ;
#line 25
void ldv_mutex_lock_7(struct mutex *ldv_func_arg1 ) ;
#line 30
void ldv_mutex_lock_lock(struct mutex *lock ) ;
#line 34
void ldv_mutex_unlock_lock(struct mutex *lock ) ;
#line 43
void ldv_mutex_lock_mutex_of_device(struct mutex *lock ) ;
#line 44
int ldv_mutex_trylock_mutex_of_device(struct mutex *lock ) ;
#line 47
void ldv_mutex_unlock_mutex_of_device(struct mutex *lock ) ;
#line 78 "include/linux/jiffies.h"
extern unsigned long volatile   jiffies ;
#line 292
extern unsigned long __msecs_to_jiffies(unsigned int const    ) ;
#line 354 "include/linux/jiffies.h"
__inline static unsigned long msecs_to_jiffies(unsigned int const   m ) 
{ 
  unsigned long tmp___0 ;

  {
#line 361
  tmp___0 = __msecs_to_jiffies(m);
#line 361
  return (tmp___0);
}
}
#line 88 "include/linux/timer.h"
extern void init_timer_key(struct timer_list * , unsigned int  , char const   * ,
                           struct lock_class_key * ) ;
#line 170
extern int mod_timer(struct timer_list * , unsigned long  ) ;
#line 229
extern int del_timer_sync(struct timer_list * ) ;
#line 62 "./arch/x86/include/asm/io.h"
__inline static unsigned int __readl(void const volatile   *addr ) 
{ 
  unsigned int ret ;

  {
#line 62
  __asm__  volatile   ("movl %1,%0": "=r" (ret): "m" (*((unsigned int volatile   *)addr)));
#line 62
  return (ret);
}
}
#line 70 "./arch/x86/include/asm/io.h"
__inline static void __writel(unsigned int val , void volatile   *addr ) 
{ 


  {
#line 70
  __asm__  volatile   ("movl %0,%1": : "r" (val), "m" (*((unsigned int volatile   *)addr)));
#line 71
  return;
}
}
#line 639 "include/linux/device.h"
extern void *devm_kmalloc(struct device * , size_t  , gfp_t  ) ;
#line 644 "include/linux/device.h"
__inline static void *devm_kzalloc(struct device *dev , size_t size , gfp_t gfp ) 
{ 
  void *tmp ;

  {
#line 646
  tmp = devm_kmalloc(dev, size, gfp | 32768U);
#line 646
  return (tmp);
}
}
#line 669
extern void *devm_ioremap_resource(struct device * , struct resource * ) ;
#line 863 "include/linux/device.h"
__inline static void *dev_get_drvdata(struct device  const  *dev ) 
{ 


  {
#line 865
  return ((void *)dev->driver_data);
}
}
#line 868 "include/linux/device.h"
__inline static void dev_set_drvdata(struct device *dev , void *data ) 
{ 


  {
#line 870
  dev->driver_data = data;
#line 871
  return;
}
}
#line 1084
extern void dev_err(struct device  const  * , char const   *  , ...) ;
#line 1086
extern void dev_warn(struct device  const  * , char const   *  , ...) ;
#line 127 "include/linux/interrupt.h"
extern int request_threaded_irq(unsigned int  , irqreturn_t (*)(int  , void * ) ,
                                irqreturn_t (*)(int  , void * ) , unsigned long  ,
                                char const   * , void * ) ;
#line 132 "include/linux/interrupt.h"
__inline static int request_irq(unsigned int irq , irqreturn_t (*handler)(int  , void * ) ,
                                unsigned long flags , char const   *name , void *dev ) 
{ 
  int tmp ;

  {
#line 135
  tmp = request_threaded_irq(irq, handler, (irqreturn_t (*)(int  , void * ))0, flags,
                             name, dev);
#line 135
  return (tmp);
}
}
#line 146
extern void free_irq(unsigned int  , void * ) ;
#line 128 "include/linux/mailbox_controller.h"
extern int mbox_controller_register(struct mbox_controller * ) ;
#line 129
extern void mbox_controller_unregister(struct mbox_controller * ) ;
#line 130
extern void mbox_chan_received_data(struct mbox_chan * , void * ) ;
#line 131
extern void mbox_chan_txdone(struct mbox_chan * , int  ) ;
#line 51 "include/linux/platform_device.h"
extern struct resource *platform_get_resource(struct platform_device * , unsigned int  ,
                                              unsigned int  ) ;
#line 53
extern int platform_get_irq(struct platform_device * , unsigned int  ) ;
#line 205 "include/linux/platform_device.h"
__inline static void *platform_get_drvdata(struct platform_device  const  *pdev ) 
{ 
  void *tmp ;

  {
#line 207
  tmp = dev_get_drvdata(& pdev->dev);
#line 207
  return (tmp);
}
}
#line 210 "include/linux/platform_device.h"
__inline static void platform_set_drvdata(struct platform_device *pdev , void *data ) 
{ 


  {
#line 213
  dev_set_drvdata(& pdev->dev, data);
#line 214
  return;
}
}
#line 63 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static struct altera_mbox *mbox_chan_to_altera_mbox(struct mbox_chan *chan ) 
{ 


  {
#line 65
  if ((unsigned long )chan == (unsigned long )((struct mbox_chan *)0) || (unsigned long )chan->con_priv == (unsigned long )((void *)0)) {
#line 66
    return ((struct altera_mbox *)0);
  } else {

  }
#line 68
  return ((struct altera_mbox *)chan->con_priv);
}
}
#line 71 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
__inline static int altera_mbox_full(struct altera_mbox *mbox ) 
{ 
  u32 status ;

  {
#line 75
  status = __readl((void const volatile   *)mbox->mbox_base + 8U);
#line 76
  return ((int )((status & 2U) >> 1));
}
}
#line 79 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
__inline static int altera_mbox_pending(struct altera_mbox *mbox ) 
{ 
  u32 status ;

  {
#line 83
  status = __readl((void const volatile   *)mbox->mbox_base + 8U);
#line 84
  return ((int )status & 1);
}
}
#line 87 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static void altera_mbox_rx_intmask(struct altera_mbox *mbox , bool enable ) 
{ 
  u32 mask ;

  {
#line 91
  mask = __readl((void const volatile   *)mbox->mbox_base + 12U);
#line 92
  if ((int )enable) {
#line 93
    mask = mask | 1U;
  } else {
#line 95
    mask = mask & 4294967294U;
  }
#line 96
  __writel(mask, (void volatile   *)mbox->mbox_base + 12U);
#line 97
  return;
}
}
#line 99 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static void altera_mbox_tx_intmask(struct altera_mbox *mbox , bool enable ) 
{ 
  u32 mask ;

  {
#line 103
  mask = __readl((void const volatile   *)mbox->mbox_base + 12U);
#line 104
  if ((int )enable) {
#line 105
    mask = mask | 2U;
  } else {
#line 107
    mask = mask & 4294967293U;
  }
#line 108
  __writel(mask, (void volatile   *)mbox->mbox_base + 12U);
#line 109
  return;
}
}
#line 111 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static bool altera_mbox_is_sender(struct altera_mbox *mbox ) 
{ 
  u32 reg ;

  {
#line 118
  __writel(2779097685U, (void volatile   *)mbox->mbox_base + 4U);
#line 119
  reg = __readl((void const volatile   *)mbox->mbox_base + 4U);
#line 120
  if (reg == 2779097685U) {
#line 122
    __writel(0U, (void volatile   *)mbox->mbox_base + 4U);
#line 123
    return (1);
  } else {

  }
#line 125
  return (0);
}
}
#line 128 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static void altera_mbox_rx_data(struct mbox_chan *chan ) 
{ 
  struct altera_mbox *mbox ;
  struct altera_mbox *tmp ;
  u32 data[2U] ;
  int tmp___0 ;

  {
#line 130
  tmp = mbox_chan_to_altera_mbox(chan);
#line 130
  mbox = tmp;
#line 133
  tmp___0 = altera_mbox_pending(mbox);
#line 133
  if (tmp___0 != 0) {
#line 134
    data[1] = __readl((void const volatile   *)mbox->mbox_base + 4U);
#line 136
    data[0] = __readl((void const volatile   *)mbox->mbox_base);
#line 138
    mbox_chan_received_data(chan, (void *)(& data));
  } else {

  }
#line 140
  return;
}
}
#line 142 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static void altera_mbox_poll_rx(unsigned long data ) 
{ 
  struct mbox_chan *chan ;
  struct altera_mbox *mbox ;
  struct altera_mbox *tmp ;
  unsigned long tmp___0 ;

  {
#line 144
  chan = (struct mbox_chan *)data;
#line 145
  tmp = mbox_chan_to_altera_mbox(chan);
#line 145
  mbox = tmp;
#line 147
  altera_mbox_rx_data(chan);
#line 149
  tmp___0 = msecs_to_jiffies(5U);
#line 149
  mod_timer(& mbox->rxpoll_timer, tmp___0 + (unsigned long )jiffies);
#line 151
  return;
}
}
#line 153 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static irqreturn_t altera_mbox_tx_interrupt(int irq , void *p ) 
{ 
  struct mbox_chan *chan ;
  struct altera_mbox *mbox ;
  struct altera_mbox *tmp ;

  {
#line 155
  chan = (struct mbox_chan *)p;
#line 156
  tmp = mbox_chan_to_altera_mbox(chan);
#line 156
  mbox = tmp;
#line 158
  altera_mbox_tx_intmask(mbox, 0);
#line 159
  mbox_chan_txdone(chan, 0);
#line 161
  return (1);
}
}
#line 164 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static irqreturn_t altera_mbox_rx_interrupt(int irq , void *p ) 
{ 
  struct mbox_chan *chan ;

  {
#line 166
  chan = (struct mbox_chan *)p;
#line 168
  altera_mbox_rx_data(chan);
#line 169
  return (1);
}
}
#line 172 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static int altera_mbox_startup_sender(struct mbox_chan *chan ) 
{ 
  int ret ;
  struct altera_mbox *mbox ;
  struct altera_mbox *tmp ;
  long tmp___0 ;

  {
#line 175
  tmp = mbox_chan_to_altera_mbox(chan);
#line 175
  mbox = tmp;
#line 177
  if ((int )mbox->intr_mode) {
#line 178
    ret = request_irq((unsigned int )mbox->irq, & altera_mbox_tx_interrupt, 0UL, "altera-mailbox",
                      (void *)chan);
#line 180
    tmp___0 = ldv__builtin_expect(ret != 0, 0L);
#line 180
    if (tmp___0 != 0L) {
#line 181
      dev_err((struct device  const  *)mbox->dev, "failed to register mailbox interrupt:%d\n",
              ret);
#line 184
      return (ret);
    } else {

    }
  } else {

  }
#line 188
  return (0);
}
}
#line 191 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static int altera_mbox_startup_receiver(struct mbox_chan *chan ) 
{ 
  int ret ;
  struct altera_mbox *mbox ;
  struct altera_mbox *tmp ;
  long tmp___0 ;
  struct lock_class_key __key ;
  unsigned long tmp___1 ;

  {
#line 194
  tmp = mbox_chan_to_altera_mbox(chan);
#line 194
  mbox = tmp;
#line 196
  if ((int )mbox->intr_mode) {
#line 197
    ret = request_irq((unsigned int )mbox->irq, & altera_mbox_rx_interrupt, 0UL, "altera-mailbox",
                      (void *)chan);
#line 199
    tmp___0 = ldv__builtin_expect(ret != 0, 0L);
#line 199
    if (tmp___0 != 0L) {
#line 200
      mbox->intr_mode = 0;
#line 201
      goto polling;
    } else {

    }
#line 204
    altera_mbox_rx_intmask(mbox, 1);
#line 205
    return (0);
  } else {

  }
  polling: 
#line 210
  init_timer_key(& mbox->rxpoll_timer, 0U, "((&mbox->rxpoll_timer))", & __key);
#line 210
  mbox->rxpoll_timer.function = & altera_mbox_poll_rx;
#line 210
  mbox->rxpoll_timer.data = (unsigned long )chan;
#line 212
  tmp___1 = msecs_to_jiffies(5U);
#line 212
  mod_timer(& mbox->rxpoll_timer, tmp___1 + (unsigned long )jiffies);
#line 215
  return (0);
}
}
#line 218 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static int altera_mbox_send_data(struct mbox_chan *chan , void *data ) 
{ 
  struct altera_mbox *mbox ;
  struct altera_mbox *tmp ;
  u32 *udata ;
  int tmp___0 ;

  {
#line 220
  tmp = mbox_chan_to_altera_mbox(chan);
#line 220
  mbox = tmp;
#line 221
  udata = (u32 *)data;
#line 223
  if ((unsigned long )mbox == (unsigned long )((struct altera_mbox *)0) || (unsigned long )data == (unsigned long )((void *)0)) {
#line 224
    return (-22);
  } else {

  }
#line 225
  if (! mbox->is_sender) {
#line 226
    dev_warn((struct device  const  *)mbox->dev, "failed to send. This is receiver mailbox.\n");
#line 228
    return (-22);
  } else {

  }
#line 231
  tmp___0 = altera_mbox_full(mbox);
#line 231
  if (tmp___0 != 0) {
#line 232
    return (-16);
  } else {

  }
#line 235
  if ((int )mbox->intr_mode) {
#line 236
    altera_mbox_tx_intmask(mbox, 1);
  } else {

  }
#line 239
  __writel(*(udata + 1UL), (void volatile   *)mbox->mbox_base + 4U);
#line 240
  __writel(*udata, (void volatile   *)mbox->mbox_base);
#line 242
  return (0);
}
}
#line 245 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static bool altera_mbox_last_tx_done(struct mbox_chan *chan ) 
{ 
  struct altera_mbox *mbox ;
  struct altera_mbox *tmp ;
  int tmp___0 ;

  {
#line 247
  tmp = mbox_chan_to_altera_mbox(chan);
#line 247
  mbox = tmp;
#line 250
  tmp___0 = altera_mbox_full(mbox);
#line 250
  return (tmp___0 == 0);
}
}
#line 253 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static bool altera_mbox_peek_data(struct mbox_chan *chan ) 
{ 
  struct altera_mbox *mbox ;
  struct altera_mbox *tmp ;
  int tmp___0 ;

  {
#line 255
  tmp = mbox_chan_to_altera_mbox(chan);
#line 255
  mbox = tmp;
#line 257
  tmp___0 = altera_mbox_pending(mbox);
#line 257
  return (tmp___0 != 0);
}
}
#line 260 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static int altera_mbox_startup(struct mbox_chan *chan ) 
{ 
  struct altera_mbox *mbox ;
  struct altera_mbox *tmp ;
  int ret ;

  {
#line 262
  tmp = mbox_chan_to_altera_mbox(chan);
#line 262
  mbox = tmp;
#line 263
  ret = 0;
#line 265
  if ((unsigned long )mbox == (unsigned long )((struct altera_mbox *)0)) {
#line 266
    return (-22);
  } else {

  }
#line 268
  if ((int )mbox->is_sender) {
#line 269
    ret = altera_mbox_startup_sender(chan);
  } else {
#line 271
    ret = altera_mbox_startup_receiver(chan);
  }
#line 273
  return (ret);
}
}
#line 276 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static void altera_mbox_shutdown(struct mbox_chan *chan ) 
{ 
  struct altera_mbox *mbox ;
  struct altera_mbox *tmp ;

  {
#line 278
  tmp = mbox_chan_to_altera_mbox(chan);
#line 278
  mbox = tmp;
#line 280
  if ((int )mbox->intr_mode) {
#line 282
    __writel(4294967295U, (void volatile   *)mbox->mbox_base + 12U);
#line 283
    free_irq((unsigned int )mbox->irq, (void *)chan);
  } else
#line 284
  if (! mbox->is_sender) {
#line 285
    del_timer_sync(& mbox->rxpoll_timer);
  } else {

  }
#line 286
  return;
}
}
#line 289 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static struct mbox_chan_ops  const  altera_mbox_ops  =    {& altera_mbox_send_data, & altera_mbox_startup, & altera_mbox_shutdown, & altera_mbox_last_tx_done,
    & altera_mbox_peek_data};
#line 297 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static int altera_mbox_probe(struct platform_device *pdev ) 
{ 
  struct altera_mbox *mbox ;
  struct resource *regs ;
  struct mbox_chan *chans ;
  int ret ;
  void *tmp ;
  void *tmp___0 ;
  long tmp___1 ;
  bool tmp___2 ;

  {
#line 304
  tmp = devm_kzalloc(& pdev->dev, 344UL, 208U);
#line 304
  mbox = (struct altera_mbox *)tmp;
#line 306
  if ((unsigned long )mbox == (unsigned long )((struct altera_mbox *)0)) {
#line 307
    return (-12);
  } else {

  }
#line 310
  tmp___0 = devm_kzalloc(& pdev->dev, 376UL, 208U);
#line 310
  chans = (struct mbox_chan *)tmp___0;
#line 311
  if ((unsigned long )chans == (unsigned long )((struct mbox_chan *)0)) {
#line 312
    return (-12);
  } else {

  }
#line 314
  regs = platform_get_resource(pdev, 512U, 0U);
#line 316
  mbox->mbox_base = devm_ioremap_resource(& pdev->dev, regs);
#line 317
  tmp___2 = IS_ERR((void const   *)mbox->mbox_base);
#line 317
  if ((int )tmp___2) {
#line 318
    tmp___1 = PTR_ERR((void const   *)mbox->mbox_base);
#line 318
    return ((int )tmp___1);
  } else {

  }
#line 321
  mbox->is_sender = altera_mbox_is_sender(mbox);
#line 323
  mbox->irq = platform_get_irq(pdev, 0U);
#line 324
  if (mbox->irq >= 0) {
#line 325
    mbox->intr_mode = 1;
  } else {

  }
#line 327
  mbox->dev = & pdev->dev;
#line 330
  chans->con_priv = (void *)mbox;
#line 331
  mbox->controller.dev = mbox->dev;
#line 332
  mbox->controller.num_chans = 1;
#line 333
  mbox->controller.chans = chans;
#line 334
  mbox->controller.ops = & altera_mbox_ops;
#line 336
  if ((int )mbox->is_sender) {
#line 337
    if ((int )mbox->intr_mode) {
#line 338
      mbox->controller.txdone_irq = 1;
    } else {
#line 340
      mbox->controller.txdone_poll = 1;
#line 341
      mbox->controller.txpoll_period = 5U;
    }
  } else {

  }
#line 345
  ret = mbox_controller_register(& mbox->controller);
#line 346
  if (ret != 0) {
#line 347
    dev_err((struct device  const  *)(& pdev->dev), "Register mailbox failed\n");
#line 348
    goto err;
  } else {

  }
#line 351
  platform_set_drvdata(pdev, (void *)mbox);
  err: ;
#line 353
  return (ret);
}
}
#line 356 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
static int altera_mbox_remove(struct platform_device *pdev ) 
{ 
  struct altera_mbox *mbox ;
  void *tmp ;

  {
#line 358
  tmp = platform_get_drvdata((struct platform_device  const  *)pdev);
#line 358
  mbox = (struct altera_mbox *)tmp;
#line 360
  if ((unsigned long )mbox == (unsigned long )((struct altera_mbox *)0)) {
#line 361
    return (-22);
  } else {

  }
#line 363
  mbox_controller_unregister(& mbox->controller);
#line 365
  return (0);
}
}
#line 373 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
struct of_device_id  const  __mod_of__altera_mbox_match_device_table[2U]  ;
#line 407
void ldv_check_final_state(void) ;
#line 410
extern void ldv_check_return_value(int  ) ;
#line 413
extern void ldv_check_return_value_probe(int  ) ;
#line 416
extern void ldv_initialize(void) ;
#line 419
extern void ldv_handler_precall(void) ;
#line 422
extern int nondet_int(void) ;
#line 425 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
int LDV_IN_INTERRUPT  ;
#line 428 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.c"
void main(void) 
{ 
  struct mbox_chan *var_group1 ;
  void *var_altera_mbox_send_data_12_p1 ;
  struct platform_device *var_group2 ;
  int res_altera_mbox_probe_17 ;
  int var_altera_mbox_rx_interrupt_9_p0 ;
  void *var_altera_mbox_rx_interrupt_9_p1 ;
  int var_altera_mbox_tx_interrupt_8_p0 ;
  void *var_altera_mbox_tx_interrupt_8_p1 ;
  int ldv_s_altera_mbox_driver_platform_driver ;
  int tmp ;
  int tmp___0 ;

  {
#line 627
  ldv_s_altera_mbox_driver_platform_driver = 0;
#line 615
  LDV_IN_INTERRUPT = 1;
#line 624
  ldv_initialize();
#line 632
  goto ldv_20250;
  ldv_20249: 
#line 636
  tmp = nondet_int();
#line 636
  switch (tmp) {
  case 0: 
#line 661
  ldv_handler_precall();
#line 662
  altera_mbox_send_data(var_group1, var_altera_mbox_send_data_12_p1);
#line 669
  goto ldv_20238;
  case 1: 
#line 693
  ldv_handler_precall();
#line 694
  altera_mbox_startup(var_group1);
#line 701
  goto ldv_20238;
  case 2: 
#line 725
  ldv_handler_precall();
#line 726
  altera_mbox_shutdown(var_group1);
#line 733
  goto ldv_20238;
  case 3: 
#line 757
  ldv_handler_precall();
#line 758
  altera_mbox_last_tx_done(var_group1);
#line 765
  goto ldv_20238;
  case 4: 
#line 789
  ldv_handler_precall();
#line 790
  altera_mbox_peek_data(var_group1);
#line 797
  goto ldv_20238;
  case 5: ;
#line 801
  if (ldv_s_altera_mbox_driver_platform_driver == 0) {
#line 821
    res_altera_mbox_probe_17 = altera_mbox_probe(var_group2);
#line 822
    ldv_check_return_value(res_altera_mbox_probe_17);
#line 823
    ldv_check_return_value_probe(res_altera_mbox_probe_17);
#line 824
    if (res_altera_mbox_probe_17 != 0) {
#line 825
      goto ldv_module_exit;
    } else {

    }
#line 826
    ldv_s_altera_mbox_driver_platform_driver = ldv_s_altera_mbox_driver_platform_driver + 1;
  } else {

  }
#line 832
  goto ldv_20238;
  case 6: ;
#line 836
  if (ldv_s_altera_mbox_driver_platform_driver == 1) {
#line 856
    ldv_handler_precall();
#line 857
    altera_mbox_remove(var_group2);
#line 858
    ldv_s_altera_mbox_driver_platform_driver = 0;
  } else {

  }
#line 864
  goto ldv_20238;
  case 7: 
#line 868
  LDV_IN_INTERRUPT = 2;
#line 888
  ldv_handler_precall();
#line 889
  altera_mbox_rx_interrupt(var_altera_mbox_rx_interrupt_9_p0, var_altera_mbox_rx_interrupt_9_p1);
#line 890
  LDV_IN_INTERRUPT = 1;
#line 896
  goto ldv_20238;
  case 8: 
#line 900
  LDV_IN_INTERRUPT = 2;
#line 920
  ldv_handler_precall();
#line 921
  altera_mbox_tx_interrupt(var_altera_mbox_tx_interrupt_8_p0, var_altera_mbox_tx_interrupt_8_p1);
#line 922
  LDV_IN_INTERRUPT = 1;
#line 928
  goto ldv_20238;
  default: ;
#line 929
  goto ldv_20238;
  }
  ldv_20238: ;
  ldv_20250: 
#line 632
  tmp___0 = nondet_int();
#line 632
  if (tmp___0 != 0 || ldv_s_altera_mbox_driver_platform_driver != 0) {
#line 635
    goto ldv_20249;
  } else {

  }

  ldv_module_exit: ;
#line 938
  ldv_check_final_state();
#line 941
  return;
}
}
#line 52 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.o.c.prepared"
__inline static long PTR_ERR(void const   *ptr ) 
{ 
  long tmp ;

  {
#line 55
  tmp = ldv_ptr_err(ptr);
#line 55
  return (tmp);
}
}
#line 58 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.o.c.prepared"
__inline static bool IS_ERR(void const   *ptr ) 
{ 
  bool tmp ;

  {
#line 61
  tmp = ldv_is_err(ptr);
#line 61
  return (tmp);
}
}
#line 70 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.o.c.prepared"
void ldv_mutex_lock_5(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 73
  ldv_mutex_lock_lock(ldv_func_arg1);
#line 75
  mutex_lock(ldv_func_arg1);
#line 76
  return;
}
}
#line 78 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.o.c.prepared"
void ldv_mutex_unlock_6(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 81
  ldv_mutex_unlock_lock(ldv_func_arg1);
#line 83
  mutex_unlock(ldv_func_arg1);
#line 84
  return;
}
}
#line 86 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.o.c.prepared"
void ldv_mutex_lock_7(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 89
  ldv_mutex_lock_mutex_of_device(ldv_func_arg1);
#line 91
  mutex_lock(ldv_func_arg1);
#line 92
  return;
}
}
#line 94 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.o.c.prepared"
int ldv_mutex_trylock_8(struct mutex *ldv_func_arg1 ) 
{ 
  ldv_func_ret_type ldv_func_res ;
  int tmp ;
  int tmp___0 ;

  {
#line 98
  tmp = mutex_trylock(ldv_func_arg1);
#line 98
  ldv_func_res = tmp;
#line 100
  tmp___0 = ldv_mutex_trylock_mutex_of_device(ldv_func_arg1);
#line 100
  return (tmp___0);
#line 102
  return (ldv_func_res);
}
}
#line 105 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/dscv/ri/32_7a/drivers/mailbox/mailbox-altera.o.c.prepared"
void ldv_mutex_unlock_9(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 108
  ldv_mutex_unlock_mutex_of_device(ldv_func_arg1);
#line 110
  mutex_unlock(ldv_func_arg1);
#line 111
  return;
}
}
#line 10 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_error(void) 
{ 


  {
  ERROR: ;
#line 12
  goto ERROR;
}
}
#line 20 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_stop(void) 
{ 


  {
  LDV_STOP: ;
#line 21
  goto LDV_STOP;
}
}
#line 25
extern int ldv_undef_int(void) ;
#line 30 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static int ldv_undef_int_negative(void) 
{ 
  int ret ;
  int tmp ;

  {
#line 32
  tmp = ldv_undef_int();
#line 32
  ret = tmp;
#line 34
  if (ret >= 0) {
#line 34
    ldv_stop();
  } else {

  }
#line 36
  return (ret);
}
}
#line 7 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err(void const   *ptr ) 
{ 


  {
#line 10
  return ((unsigned long )ptr > 2012UL);
}
}
#line 14 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
void *ldv_err_ptr(long error ) 
{ 


  {
#line 17
  return ((void *)(2012L - error));
}
}
#line 21 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
long ldv_ptr_err(void const   *ptr ) 
{ 


  {
#line 24
  return ((long )(2012UL - (unsigned long )ptr));
}
}
#line 28 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err_or_null(void const   *ptr ) 
{ 
  bool tmp ;
  int tmp___0 ;

  {
#line 31
  if ((unsigned long )ptr == (unsigned long )((void const   *)0)) {
#line 31
    tmp___0 = 1;
  } else {
#line 31
    tmp = ldv_is_err(ptr);
#line 31
    if ((int )tmp) {
#line 31
      tmp___0 = 1;
    } else {
#line 31
      tmp___0 = 0;
    }
  }
#line 31
  return ((bool )tmp___0);
}
}
#line 8 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
static int ldv_mutex_lock  =    1;
#line 11 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_interruptible_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 16
  if (ldv_mutex_lock != 1) {
#line 16
    ldv_error();
  } else {

  }
#line 19
  nondetermined = ldv_undef_int();
#line 22
  if (nondetermined != 0) {
#line 25
    ldv_mutex_lock = 2;
#line 27
    return (0);
  } else {
#line 32
    return (-4);
  }
}
}
#line 37 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_killable_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 42
  if (ldv_mutex_lock != 1) {
#line 42
    ldv_error();
  } else {

  }
#line 45
  nondetermined = ldv_undef_int();
#line 48
  if (nondetermined != 0) {
#line 51
    ldv_mutex_lock = 2;
#line 53
    return (0);
  } else {
#line 58
    return (-4);
  }
}
}
#line 63 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_lock_lock(struct mutex *lock ) 
{ 


  {
#line 66
  if (ldv_mutex_lock != 1) {
#line 66
    ldv_error();
  } else {

  }
#line 68
  ldv_mutex_lock = 2;
#line 69
  return;
}
}
#line 72 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_trylock_lock(struct mutex *lock ) 
{ 
  int is_mutex_held_by_another_thread ;

  {
#line 77
  if (ldv_mutex_lock != 1) {
#line 77
    ldv_error();
  } else {

  }
#line 80
  is_mutex_held_by_another_thread = ldv_undef_int();
#line 83
  if (is_mutex_held_by_another_thread != 0) {
#line 86
    return (0);
  } else {
#line 91
    ldv_mutex_lock = 2;
#line 93
    return (1);
  }
}
}
#line 98 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_atomic_dec_and_mutex_lock_lock(atomic_t *cnt , struct mutex *lock ) 
{ 
  int atomic_value_after_dec ;

  {
#line 103
  if (ldv_mutex_lock != 1) {
#line 103
    ldv_error();
  } else {

  }
#line 106
  atomic_value_after_dec = ldv_undef_int();
#line 109
  if (atomic_value_after_dec == 0) {
#line 112
    ldv_mutex_lock = 2;
#line 114
    return (1);
  } else {

  }
#line 118
  return (0);
}
}
#line 123 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_is_locked_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 127
  if (ldv_mutex_lock == 1) {
#line 130
    nondetermined = ldv_undef_int();
#line 133
    if (nondetermined != 0) {
#line 136
      return (0);
    } else {
#line 141
      return (1);
    }
  } else {
#line 147
    return (1);
  }
}
}
#line 152 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_unlock_lock(struct mutex *lock ) 
{ 


  {
#line 155
  if (ldv_mutex_lock != 2) {
#line 155
    ldv_error();
  } else {

  }
#line 157
  ldv_mutex_lock = 1;
#line 158
  return;
}
}
#line 163 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_lock_device_lock(void) 
{ 


  {
#line 166
  ldv_mutex_lock_lock((struct mutex *)0);
#line 167
  return;
}
}
#line 170 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_trylock_device_lock(void) 
{ 
  int tmp ;

  {
#line 172
  tmp = ldv_mutex_trylock_lock((struct mutex *)0);
#line 172
  return (tmp);
}
}
#line 176 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_lock_device_for_reset_lock(void) 
{ 
  int tmp ;
  int tmp___0 ;

  {
#line 178
  tmp___0 = ldv_undef_int();
#line 178
  if (tmp___0 != 0) {
#line 180
    ldv_mutex_lock_lock((struct mutex *)0);
#line 182
    return (0);
  } else {
#line 185
    tmp = ldv_undef_int_negative();
#line 185
    return (tmp);
  }
}
}
#line 189 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_unlock_device_lock(void) 
{ 


  {
#line 191
  ldv_mutex_unlock_lock((struct mutex *)0);
#line 192
  return;
}
}
#line 194 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
static int ldv_mutex_mutex_of_device  =    1;
#line 197 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_interruptible_mutex_of_device(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 202
  if (ldv_mutex_mutex_of_device != 1) {
#line 202
    ldv_error();
  } else {

  }
#line 205
  nondetermined = ldv_undef_int();
#line 208
  if (nondetermined != 0) {
#line 211
    ldv_mutex_mutex_of_device = 2;
#line 213
    return (0);
  } else {
#line 218
    return (-4);
  }
}
}
#line 223 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_killable_mutex_of_device(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 228
  if (ldv_mutex_mutex_of_device != 1) {
#line 228
    ldv_error();
  } else {

  }
#line 231
  nondetermined = ldv_undef_int();
#line 234
  if (nondetermined != 0) {
#line 237
    ldv_mutex_mutex_of_device = 2;
#line 239
    return (0);
  } else {
#line 244
    return (-4);
  }
}
}
#line 249 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_lock_mutex_of_device(struct mutex *lock ) 
{ 


  {
#line 252
  if (ldv_mutex_mutex_of_device != 1) {
#line 252
    ldv_error();
  } else {

  }
#line 254
  ldv_mutex_mutex_of_device = 2;
#line 255
  return;
}
}
#line 258 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_trylock_mutex_of_device(struct mutex *lock ) 
{ 
  int is_mutex_held_by_another_thread ;

  {
#line 263
  if (ldv_mutex_mutex_of_device != 1) {
#line 263
    ldv_error();
  } else {

  }
#line 266
  is_mutex_held_by_another_thread = ldv_undef_int();
#line 269
  if (is_mutex_held_by_another_thread != 0) {
#line 272
    return (0);
  } else {
#line 277
    ldv_mutex_mutex_of_device = 2;
#line 279
    return (1);
  }
}
}
#line 284 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_atomic_dec_and_mutex_lock_mutex_of_device(atomic_t *cnt , struct mutex *lock ) 
{ 
  int atomic_value_after_dec ;

  {
#line 289
  if (ldv_mutex_mutex_of_device != 1) {
#line 289
    ldv_error();
  } else {

  }
#line 292
  atomic_value_after_dec = ldv_undef_int();
#line 295
  if (atomic_value_after_dec == 0) {
#line 298
    ldv_mutex_mutex_of_device = 2;
#line 300
    return (1);
  } else {

  }
#line 304
  return (0);
}
}
#line 309 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_is_locked_mutex_of_device(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 313
  if (ldv_mutex_mutex_of_device == 1) {
#line 316
    nondetermined = ldv_undef_int();
#line 319
    if (nondetermined != 0) {
#line 322
      return (0);
    } else {
#line 327
      return (1);
    }
  } else {
#line 333
    return (1);
  }
}
}
#line 338 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_unlock_mutex_of_device(struct mutex *lock ) 
{ 


  {
#line 341
  if (ldv_mutex_mutex_of_device != 2) {
#line 341
    ldv_error();
  } else {

  }
#line 343
  ldv_mutex_mutex_of_device = 1;
#line 344
  return;
}
}
#line 349 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_lock_device_mutex_of_device(void) 
{ 


  {
#line 352
  ldv_mutex_lock_mutex_of_device((struct mutex *)0);
#line 353
  return;
}
}
#line 356 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_trylock_device_mutex_of_device(void) 
{ 
  int tmp ;

  {
#line 358
  tmp = ldv_mutex_trylock_mutex_of_device((struct mutex *)0);
#line 358
  return (tmp);
}
}
#line 362 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_lock_device_for_reset_mutex_of_device(void) 
{ 
  int tmp ;
  int tmp___0 ;

  {
#line 364
  tmp___0 = ldv_undef_int();
#line 364
  if (tmp___0 != 0) {
#line 366
    ldv_mutex_lock_mutex_of_device((struct mutex *)0);
#line 368
    return (0);
  } else {
#line 371
    tmp = ldv_undef_int_negative();
#line 371
    return (tmp);
  }
}
}
#line 375 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_unlock_device_mutex_of_device(void) 
{ 


  {
#line 377
  ldv_mutex_unlock_mutex_of_device((struct mutex *)0);
#line 378
  return;
}
}
#line 382 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10978/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_check_final_state(void) 
{ 


  {
#line 385
  if (ldv_mutex_lock != 1) {
#line 385
    ldv_error();
  } else {

  }
#line 387
  if (ldv_mutex_mutex_of_device != 1) {
#line 387
    ldv_error();
  } else {

  }
#line 391
  return;
}
}
